//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif

#ifndef STRINGR
#define STRINGR 
#include<stringR.h>
#endif

#ifndef WSTRING
#define WSTRING
#include <wString.h>
#endif



unsigned const long RD=GENERIC_READ;
const unsigned long WR=GENERIC_WRITE;
const unsigned long ShareRead=FILE_SHARE_READ;
const unsigned long ShareWrite=FILE_SHARE_WRITE;
const unsigned long NotShare=0;
const unsigned long FERR_SUCCESS = 0 ;
const unsigned long FERR_ERR = 1 ;
const unsigned long FERR_EOF = 2 ;


bool Move_Pointer(HANDLE file,LARGE_INTEGER movebyte, DWORD startpoint);
HANDLE Open_File(WCHAR *FileName,DWORD accestype,DWORD sharemode,bool CanCreate);//supports huge  filepaths does not need the //?/ prefix
bool Write_File(HANDLE outf,char *data,unsigned long &len);
int Read_File(HANDLE file,char *buf,unsigned long buflen,unsigned long &bytesread);
int Read_FileTXTU(HANDLE file,WCHAR *& nbuf,unsigned long &bytesread);// the nbuf will being allocated inside the routine if error nbuf == NULL. 
                                                                     //The file must be crlf line terminated , if return 2 the the file has ended. if returned 1 then error if return 0 then success
int Read_FileTXTANSI(HANDLE file,char *buf,unsigned long buflen,unsigned long &bytesread);

bool Copy_File(WCHAR *source, WCHAR *dest); //the routine inserts the prefix for  huge filepaths

void EmptyFile( HANDLE fl );


//code


bool Move_Pointer(HANDLE file,LARGE_INTEGER movebyte, DWORD startpoint)
{

 LARGE_INTEGER ret;
if (SetFilePointerEx(file,movebyte,&ret,startpoint)== 0xFFFFFFFF)
{
 return false;
}
return true;
}


HANDLE Open_File(WCHAR *FileName,DWORD accestype,DWORD sharemode,bool CanCreate)
{

    long Action=OPEN_EXISTING;
    if (CanCreate==true) Action=OPEN_ALWAYS;

wString filen;
filen=L"\\\\?\\";
filen+FileName;

 HANDLE file=CreateFileW(FileName,accestype,sharemode,NULL,Action,
    FILE_ATTRIBUTE_NORMAL,NULL);
filen.~wString();

if (file==INVALID_HANDLE_VALUE)
{
    CloseHandle(file);
    return 0;
}


return file;

};

bool Write_File(HANDLE outf,char *data,unsigned long &len)
{

    if (outf==NULL) return false;


    char *buff=new char[len];
    ZeroMemory(buff,len);
	
    CopyMemory(buff,data,(len));

    unsigned long numwr=0;
    if (WriteFile(outf,buff,len,&numwr,NULL)==false)
    {
      delete [] buff;
      return false;
    };
    if (numwr!=len)
    {
      delete [] buff;
      return false;
    }

   len=numwr;
   delete [] buff;
   return true;
};


int Read_File(HANDLE file,char *buf,unsigned long buflen,unsigned long &bytesread)
{

    bytesread=0;

    bool res=ReadFile(file,buf,buflen,&bytesread,NULL);
    if ((res==false)&&(bytesread!=0))
{
return 1;//error
}

      if ((res==true)&&(bytesread==0))
      {
        return 2;//eof
      }




    return 0;
};


int Read_FileTXTU(HANDLE file,WCHAR *&nbuf,unsigned long &bytesread)
{

    bytesread=0;
    WCHAR buf[2048];
    bool hadBOM = false;

bool res=ReadFile(file,buf,2047,&bytesread,NULL); // read 2047 characters from file
if (bytesread == 0) // End Of File
{
    nbuf = NULL ;
    return FERR_EOF ;
}

if (res == false)
{
nbuf=NULL;
return FERR_ERR;//error
}

    buf[bytesread] = 0;// zero at the end of the string

//check for BOM
if (buf[0]==0xFFFE || buf[0]==0xFEFF)
{
    // we need to know if this two bytes were removed later on so we can calculate the pointer offset correctly.
    hadBOM = true ;
    // remove BOM

    if (buf[0]==0xFFFE)
    nbuf=RemoveChar(buf, 0xFFFE);
        else
              nbuf=RemoveChar(buf, 0xFEFF);

} else
        {
          ULONG nindx=0;
          nbuf = CopyToIndex(buf,2047,nindx);
        }

//in this point we have the string with no BOM , just the text
bool hasCR = false;

    for(ULONG i=0;i<2047;i++)//
    {

        if ((nbuf[i]== 10)||(nbuf[i]==0)) // if LF or 0 the line is ending here
    {
        if (nbuf[i]==10)
        {
            if ( nbuf[i-1] == 13 )
            {
                nbuf[i-1] = 0;
                hasCR = true ;
            }

            else
                nbuf[i] = 0; // the crlf is now ommited
        }


        LARGE_INTEGER st;
        ULONG offst , ibom = 0 , icr = 0 ;

        if ( hadBOM == true ) ibom = 2 ;
        if ( hasCR == true ) icr = 2 ;

        offst = (bytesread-((i*2)+icr+ibom));

        st.QuadPart=(__int64)offst*-1;



        Move_Pointer(file,st,FILE_CURRENT);//move the pointer

        return FERR_SUCCESS; // return no error
    }//if buff

    }//for i

    return 0;
};


int Read_FileTXTANSI(HANDLE file,char *buf,unsigned long buflen,unsigned long &bytesread)
{

    bytesread=0;
    ZeroMemory(buf,buflen);
    bool res=ReadFile(file,buf,buflen,&bytesread,NULL);

    bool txt=true;

    if ((res==false)&&(bytesread!=0))
{
return 1;//error
}
    if((txt==true)&&(bytesread!=0)) 

    for(ULONG i=0;i<buflen;i++)
    {

        if ((buf[i]==10)||(buf[i]==0))
    {
        if (buf[i]==10)
        buf[i-1]=0;
       
        LARGE_INTEGER st;
        st.QuadPart=(__int64)((bytesread-(i+1)))*(-1);

        Move_Pointer(file,st,FILE_CURRENT);

        if ((res==true)&&(bytesread==0)) return 2;//eof
        return 0;
    }//if buff

    }//for i

      if ((res==true)&&(bytesread==0))
      {
        return 2;//eof
      }




    return 0;
};


WCHAR * InsertHugeFilePathPrefixw(WCHAR *filename)
{
    WCHAR pref[5];
    WCHAR UNCPREF[4];

    CopyStr(UNCPREF,L"UNC",4);
    CopyStr(pref,L"\\\\?\\",4);

      if (filename[1]!=L':')

        {
            wString t;
            t=pref;
            t+UNCPREF;
            t+filename;
            ULONG indx=0;
            WCHAR * ret=ReplaceTextw(t.Str(),L"\\\\?\\UNC\\\\",L"\\\\?\\UNC\\",false,indx);
            t.~wString();
            return ret;

        }


    WCHAR * ret = ConCat(pref,filename);

    return ret;

}


bool Copy_File(WCHAR *source, WCHAR *dest)
{
    WCHAR * src = InsertHugeFilePathPrefixw(source);
    WCHAR * dst = InsertHugeFilePathPrefixw(dest);

    bool ret=CopyFile(src,dst,false);

    return ret;

}

void EmptyFile( HANDLE fl )
{
  LARGE_INTEGER i ;
  i.QuadPart = (__int64) 0 ;
  SetFilePointerEx( fl , i , NULL , FILE_BEGIN ) ;
  SetEndOfFile( fl ) ;
}

























